
import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import static ucar.httpservices.CustomX509TrustManager.logger;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author José Geraldo
 */
public class Principal extends javax.swing.JFrame {

    /**
     * Creates new form Principal
     */
    public Principal() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        abaGeral = new javax.swing.JTabbedPane();
        abaSobre = new javax.swing.JScrollPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        abaDocumentos = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        labelPastaDocumentos = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        tabelaDocumentos = new javax.swing.JTable();
        atualizarDocumentos = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        abaArquivosIndex = new javax.swing.JTabbedPane();
        jPanel4 = new javax.swing.JPanel();
        labelPastaIndex = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        tabelaIndex = new javax.swing.JTable();
        atualizarIndex = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jScrollPane6 = new javax.swing.JScrollPane();
        jScrollPane5 = new javax.swing.JScrollPane();
        indexInformativo = new javax.swing.JTextArea();
        limpaTelaExecucao = new javax.swing.JToggleButton();
        abaBusca = new javax.swing.JTabbedPane();
        abaBuscaVetorial = new javax.swing.JPanel();
        botaoBuscaLucene = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        buscaInformativoLucene = new javax.swing.JTextArea();
        campoBuscaLucene = new javax.swing.JTextField();
        abaBuscaBM25 = new javax.swing.JPanel();
        botaoBuscaBM25 = new javax.swing.JButton();
        campoBuscaBM25 = new javax.swing.JTextField();
        jScrollPane7 = new javax.swing.JScrollPane();
        buscaInformativoBM25 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);
        setSize(new java.awt.Dimension(400, 300));

        jPanel2.setPreferredSize(new java.awt.Dimension(530, 1575));

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/trabalho_pratico_01.png"))); // NOI18N

        jLabel1.setFont(new java.awt.Font("Arial", 1, 24)); // NOI18N
        jLabel1.setText("JOSÉ GERALDO DANTAS NUNES");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel2)
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(349, 349, 349)
                .addComponent(jLabel1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 1511, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        abaSobre.setViewportView(jPanel2);

        abaGeral.addTab("Sobre", abaSobre);

        labelPastaDocumentos.setText("Pasta ");

        tabelaDocumentos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "ID", "ARQUIVO", "TIPO", "TAMANHO"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tabelaDocumentos.getTableHeader().setReorderingAllowed(false);
        jScrollPane3.setViewportView(tabelaDocumentos);

        atualizarDocumentos.setText("Atualizar");
        atualizarDocumentos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                atualizarDocumentosActionPerformed(evt);
            }
        });

        jButton1.setText("Sair");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane3)
                        .addContainerGap())
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(atualizarDocumentos)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(labelPastaDocumentos)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1)
                        .addGap(24, 24, 24))))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPastaDocumentos)
                    .addComponent(atualizarDocumentos)
                    .addComponent(jButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3)
                .addContainerGap())
        );

        abaDocumentos.setViewportView(jPanel3);

        abaGeral.addTab("Documentos", abaDocumentos);

        labelPastaIndex.setText("Pasta ");

        tabelaIndex.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "ID", "ARQUIVO", "TIPO", "TAMANHO"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane4.setViewportView(tabelaIndex);

        atualizarIndex.setText("Atualizar");
        atualizarIndex.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                atualizarIndexActionPerformed(evt);
            }
        });

        jButton2.setText("Apagar");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 1367, Short.MAX_VALUE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(atualizarIndex)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(8, 8, 8)
                        .addComponent(labelPastaIndex)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPastaIndex)
                    .addComponent(atualizarIndex)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 446, Short.MAX_VALUE)
                .addContainerGap())
        );

        abaArquivosIndex.addTab("Documentos", jPanel4);

        jButton3.setText("Executar");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        indexInformativo.setColumns(20);
        indexInformativo.setRows(5);
        jScrollPane5.setViewportView(indexInformativo);

        jScrollPane6.setViewportView(jScrollPane5);

        limpaTelaExecucao.setText("Limpar Tela");
        limpaTelaExecucao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                limpaTelaExecucaoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 1387, Short.MAX_VALUE)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(limpaTelaExecucao, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(4, 4, 4)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton3)
                    .addComponent(limpaTelaExecucao))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE))
        );

        abaArquivosIndex.addTab("Indexar", jPanel5);

        abaGeral.addTab("Índex", abaArquivosIndex);

        botaoBuscaLucene.setText("BUSCA");
        botaoBuscaLucene.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoBuscaLuceneActionPerformed(evt);
            }
        });

        buscaInformativoLucene.setColumns(20);
        buscaInformativoLucene.setRows(5);
        jScrollPane2.setViewportView(buscaInformativoLucene);

        javax.swing.GroupLayout abaBuscaVetorialLayout = new javax.swing.GroupLayout(abaBuscaVetorial);
        abaBuscaVetorial.setLayout(abaBuscaVetorialLayout);
        abaBuscaVetorialLayout.setHorizontalGroup(
            abaBuscaVetorialLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(abaBuscaVetorialLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(abaBuscaVetorialLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(abaBuscaVetorialLayout.createSequentialGroup()
                        .addComponent(botaoBuscaLucene, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(campoBuscaLucene, javax.swing.GroupLayout.PREFERRED_SIZE, 254, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 675, Short.MAX_VALUE))
                    .addComponent(jScrollPane2))
                .addContainerGap())
        );
        abaBuscaVetorialLayout.setVerticalGroup(
            abaBuscaVetorialLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(abaBuscaVetorialLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(abaBuscaVetorialLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(botaoBuscaLucene)
                    .addComponent(campoBuscaLucene, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 446, Short.MAX_VALUE)
                .addContainerGap())
        );

        abaBusca.addTab("VETORIAL", abaBuscaVetorial);

        botaoBuscaBM25.setText("BUSCA");
        botaoBuscaBM25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoBuscaBM25ActionPerformed(evt);
            }
        });

        buscaInformativoBM25.setColumns(20);
        buscaInformativoBM25.setRows(5);
        jScrollPane7.setViewportView(buscaInformativoBM25);

        javax.swing.GroupLayout abaBuscaBM25Layout = new javax.swing.GroupLayout(abaBuscaBM25);
        abaBuscaBM25.setLayout(abaBuscaBM25Layout);
        abaBuscaBM25Layout.setHorizontalGroup(
            abaBuscaBM25Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(abaBuscaBM25Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(abaBuscaBM25Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane7)
                    .addGroup(abaBuscaBM25Layout.createSequentialGroup()
                        .addComponent(botaoBuscaBM25, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(campoBuscaBM25, javax.swing.GroupLayout.PREFERRED_SIZE, 254, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 679, Short.MAX_VALUE)))
                .addContainerGap())
        );
        abaBuscaBM25Layout.setVerticalGroup(
            abaBuscaBM25Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(abaBuscaBM25Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(abaBuscaBM25Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(botaoBuscaBM25)
                    .addComponent(campoBuscaBM25, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 446, Short.MAX_VALUE)
                .addContainerGap())
        );

        abaBusca.addTab("BM25", abaBuscaBM25);

        abaGeral.addTab("Busca", abaBusca);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(abaGeral, javax.swing.GroupLayout.DEFAULT_SIZE, 1042, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(abaGeral, javax.swing.GroupLayout.DEFAULT_SIZE, 553, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void botaoBuscaBM25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoBuscaBM25ActionPerformed
        // TODO add your handling code here:
        // TODO add your handling code here:
        buscaInformativoBM25.selectAll();
        buscaInformativoBM25.replaceSelection("");

        String termo = new String();
        Buscador buscar = new Buscador();
        ArrayList<String> listaInformativa = new ArrayList<String>();

        try{
            termo = campoBuscaBM25.getText();
            listaInformativa = buscar.modelo_BM25(termo);
        }
        catch(Exception erro){ System.out.println("Erro"); }

        buscaInformativoBM25.setText("");
        buscaInformativoBM25.append("MÉTODO DE BUSCA: Modelo BM25 \n\n");
        buscaInformativoBM25.append("TERMO DE CONSULTA: "+termo+"\n\n");

        if(!listaInformativa.isEmpty()){

            //imprime o resultado da busca na tela informativa
            for(int a=0; a<listaInformativa.size();a++){
                buscaInformativoBM25.append(listaInformativa.get(a) + "\n" );

                try { Thread.sleep( 500 ); }
                catch( InterruptedException e ) { e.printStackTrace(); }
            }
            buscaInformativoBM25.append("\n*** PROCESSO DE BUSCA FINALIZADO *** ");
        }
        else{ JOptionPane.showMessageDialog(null,"Nenhum documento relevante encontrado com o termo informado."); }
    }//GEN-LAST:event_botaoBuscaBM25ActionPerformed

    private void botaoBuscaLuceneActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoBuscaLuceneActionPerformed
        // TODO add your handling code here:
        // TODO add your handling code here:
        buscaInformativoLucene.selectAll();
        buscaInformativoLucene.replaceSelection("");

        String termo = new String();
        Buscador buscar = new Buscador();
        ArrayList<String> listaInformativa = new ArrayList<String>();

        termo = campoBuscaLucene.getText();
        listaInformativa = buscar.modelo_Vetorial(termo);
        buscaInformativoLucene.setText("");
        buscaInformativoLucene.append("MÉTODO DE BUSCA: Modelo Vetorial \n\n");
        buscaInformativoLucene.append("TERMO DE CONSULTA: "+termo+"\n\n");

        //verifica se foi encontrado algum registro para ser exibido
        if(!listaInformativa.isEmpty()){

            //imprime o resultado da busca na tela informativa
            for(int a=0; a<listaInformativa.size();a++){
                buscaInformativoLucene.append(listaInformativa.get(a) + "\n" );

                try { Thread.sleep( 500 ); }
                catch( InterruptedException e ) { e.printStackTrace(); }
            }
            buscaInformativoLucene.append("*** PROCESSO DE BUSCA FINALIZADO *** ");
        }
        else{ JOptionPane.showMessageDialog(null,"Nenhum documento relevante encontrado com o termo informado."); }
    }//GEN-LAST:event_botaoBuscaLuceneActionPerformed

    private void limpaTelaExecucaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_limpaTelaExecucaoActionPerformed
        // TODO add your handling code here:
        indexInformativo.selectAll();
        indexInformativo.replaceSelection("");
    }//GEN-LAST:event_limpaTelaExecucaoActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        // Executa o processo de indexação de documentos
        ArrayList<String> listaInformativa = new ArrayList<String>();
        Indexador indexador = new Indexador();
        String inicio = "*** INÍCIO DO PROCESSO DE INDEXAÇÂO - AGUARDE *** \n\n\n";
        indexInformativo.append(inicio);
        listaInformativa = indexador.indexaArquivosDoDiretorio();

        if(listaInformativa.isEmpty()){ JOptionPane.showMessageDialog(null,"A indexação de arquivos não foi executada.\nVerifique se há arquivos para indexar."); }
        else{
            for(int a=0; a<listaInformativa.size();a++){
                indexInformativo.append(listaInformativa.get(a) + "\n" );

                try { Thread.sleep( 500 ); }
                catch( InterruptedException e ) { e.printStackTrace(); }
            }
            indexInformativo.append("\n\n\n*** PROCESSO DE INDEXAÇÂO FINALIZADO *** ");
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        Indexador indexador = new Indexador();
        File src = new File(indexador.diretorio_src_dos_indices);
        File build = new File(indexador.diretorio_src_dos_indices);
        File teste = new File(indexador.diretorio_teste_dos_indices);

        indexador.apagaIndices(src);
        indexador.apagaIndices(build);
        indexador.apagaIndices(teste);
        atualizaTabelaIndex();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void atualizarIndexActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_atualizarIndexActionPerformed
        // TODO add your handling code here:

        Index index = new Index();
        ArrayList<Index> listaIndex = new ArrayList<Index>();
        labelPastaIndex.setText(index.getDiretorio());

        try{
            // recupera a lista de arquivos disponíveis na bilioteca
            listaIndex = index.localizaIndices();

            if(!listaIndex.isEmpty()){
                // preenche a tabela informativa de documentos disponíveis na biblioteca
                preencheTabelaIndices(listaIndex);
            }
            else{ JOptionPane.showMessageDialog(null,"Nenhum arquivo de índice foi localizado"); }

        }catch(Exception erro){
            erro.printStackTrace();
            JOptionPane.showMessageDialog(null,"Erro ao abrir os arquivos.\nCertifique-se que há arquivos para serem analisados");
        }
    }//GEN-LAST:event_atualizarIndexActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void atualizarDocumentosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_atualizarDocumentosActionPerformed
        // TODO add your handling code here:

        Documento documento = new Documento();
        ArrayList<Documento> listaDocumentos = new ArrayList<Documento>();
        labelPastaDocumentos.setText(documento.getDiretorio());

        try{
            // recupera a lista de arquivos disponíveis na bilioteca
            listaDocumentos = documento.localizaDocumentos();

            if(!listaDocumentos.isEmpty()){
                // preenche a tabela informativa de documentos disponíveis na biblioteca
                preencheTabelaDocumentos(listaDocumentos);
            }
            else{ JOptionPane.showMessageDialog(null,"Nenhum arquivo foi localizado"); }

        }catch(Exception erro){
            erro.printStackTrace();
            JOptionPane.showMessageDialog(null,"Erro ao abrir os arquivos.\nCertifique-se que há arquivos para serem analisados");
        }
    }//GEN-LAST:event_atualizarDocumentosActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        
        
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Principal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Principal().setVisible(true);
            }
        });        
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane abaArquivosIndex;
    private javax.swing.JTabbedPane abaBusca;
    private javax.swing.JPanel abaBuscaBM25;
    private javax.swing.JPanel abaBuscaVetorial;
    private javax.swing.JScrollPane abaDocumentos;
    private javax.swing.JTabbedPane abaGeral;
    private javax.swing.JScrollPane abaSobre;
    private javax.swing.JButton atualizarDocumentos;
    private javax.swing.JButton atualizarIndex;
    private javax.swing.JButton botaoBuscaBM25;
    private javax.swing.JButton botaoBuscaLucene;
    private javax.swing.JTextArea buscaInformativoBM25;
    private javax.swing.JTextArea buscaInformativoLucene;
    private javax.swing.JTextField campoBuscaBM25;
    private javax.swing.JTextField campoBuscaLucene;
    private javax.swing.JTextArea indexInformativo;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JLabel labelPastaDocumentos;
    private javax.swing.JLabel labelPastaIndex;
    private javax.swing.JToggleButton limpaTelaExecucao;
    private javax.swing.JTable tabelaDocumentos;
    private javax.swing.JTable tabelaIndex;
    // End of variables declaration//GEN-END:variables


private void preencheTabelaDocumentos(ArrayList<Documento> documento){
        
        tabelaDocumentos.getTableHeader().setReorderingAllowed(false);          
        final DefaultTableModel dm = new DefaultTableModel(); 
        tabelaDocumentos.setModel(dm);
        
        dm.addColumn("ID");
        dm.addColumn("ARQUIVO");
        dm.addColumn("TIPO");
        dm.addColumn("TAMANHO");
        
        tabelaDocumentos.getColumnModel().getColumn(0).setPreferredWidth(45);
        tabelaDocumentos.getColumnModel().getColumn(1).setPreferredWidth(700);
        tabelaDocumentos.getColumnModel().getColumn(2).setPreferredWidth(50); 
        tabelaDocumentos.getColumnModel().getColumn(3).setPreferredWidth(100); 
        
        for(int a=0;a < documento.size();a++){   
            dm.addRow(new Object[]{null, null, null, null});
            tabelaDocumentos.setValueAt(documento.get(a).getId(), a, 0);  
            tabelaDocumentos.setValueAt(documento.get(a).getNome(), a, 1);       
            tabelaDocumentos.setValueAt(documento.get(a).getTipo(), a, 2);     
            tabelaDocumentos.setValueAt(documento.get(a).getTamanho(), a, 3);  
        }           
        dm.addRow(new Object[]{null, null, null, null});
        dm.addRow(new Object[]{null, null, null, null});
        tabelaDocumentos.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        tabelaDocumentos.revalidate();  
    } 
    
    private void preencheTabelaIndices(ArrayList<Index> index){

        tabelaIndex.getTableHeader().setReorderingAllowed(false);          
        final DefaultTableModel dm = new DefaultTableModel(); 
        tabelaIndex.setModel(dm);

        dm.addColumn("ID");
        dm.addColumn("ARQUIVO");
        dm.addColumn("TIPO");
        dm.addColumn("TAMANHO");

        tabelaIndex.getColumnModel().getColumn(0).setPreferredWidth(45);
        tabelaIndex.getColumnModel().getColumn(1).setPreferredWidth(700);
        tabelaIndex.getColumnModel().getColumn(2).setPreferredWidth(50); 
        tabelaIndex.getColumnModel().getColumn(3).setPreferredWidth(100); 

        for(int a=0;a < index.size();a++){   
            dm.addRow(new Object[]{null, null, null, null});
            tabelaIndex.setValueAt(index.get(a).getId(), a, 0);  
            tabelaIndex.setValueAt(index.get(a).getNome(), a, 1);       
            tabelaIndex.setValueAt(index.get(a).getTipo(), a, 2);     
            tabelaIndex.setValueAt(index.get(a).getTamanho(), a, 3);  
        }           
        dm.addRow(new Object[]{null, null, null, null});
        dm.addRow(new Object[]{null, null, null, null});
        tabelaIndex.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        tabelaIndex.revalidate();  
    } 

     private void atualizaTabelaIndex(){
      
        final DefaultTableModel dm = new DefaultTableModel(); 
        tabelaIndex.getTableHeader().setReorderingAllowed(false);    
        tabelaIndex.setModel(dm);
        
        // ciar colunas na tabela
        dm.addColumn("ID");
        dm.addColumn("ARQUIVO");
        dm.addColumn("TIPO");
        dm.addColumn("TAMANHO");
        
        tabelaIndex.getColumnModel().getColumn(0).setPreferredWidth(45);
        tabelaIndex.getColumnModel().getColumn(1).setPreferredWidth(700);
        tabelaIndex.getColumnModel().getColumn(2).setPreferredWidth(50); 
        tabelaIndex.getColumnModel().getColumn(3).setPreferredWidth(100); 
        tabelaIndex.updateUI();
        
        //adiciona 30 linhas vazias na tabela
        for(int a=0;a < 30;a++){   
            dm.addRow(new Object[]{null, null, null, null});
        }        
        
        tabelaIndex.clearSelection();
        dm.addRow(new Object[]{null, null, null, null});
        dm.addRow(new Object[]{null, null, null, null});
        tabelaIndex.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        tabelaIndex.revalidate();  
    } 
    
    
}
